/*
 * grp2c translator for Grapnel environment, parser (pwindcl.h)
 *
 * Copyright (c) Drotos Daniel, University of Miskolc. 1994,98
 *
 */

/* This file is part of parser library which is part of grp2c
   translator program for GRAPNEL environment.

   The GRAPNEL system is part of SEPP project. This project is
   supported by the EC within COPERNICUS Research Project
   No. 5383. The grp2c (Grapnel Compiler) translates GRP files,
   generated by the Graphical Program Editor (GRED), into C
   source. Latest version of the grapnel compiler is available on site
   mazsola:

   http://mazsola.iit.uni-miskolc.hu/~dani/grp2c
*/
/*@1@*/

#ifndef PWindClHeader
#define PWindClHeader

#include "ddconfig.h"

#include "parstyps.h"
#include "pobj.h"
#include "pgroupcl.h"
#include "pparamcl.h"


typedef class TprsWindow     *PprsWindow;
typedef class TprsWindowColl *PprsWindowColl;


class TprsWindow: public TObject
{
public:
  char          *Name;
  PprsGroupColl Groups;

               TprsWindow(char *AName);
  virtual      ~TprsWindow(void);
  virtual int  Init(void);

          PprsGroup     GetGroup(char *AName);
  virtual void          ShowData(FILE *To, char *Pre);
  virtual void          WriteGRP(FILE *To, int Ind);
};


class TprsWindowColl: public TCollection
{
public:
          TprsWindowColl(void);
  virtual ~TprsWindowColl(void);

          PprsWindow GetWindow(char *AName);
  virtual void       ShowData(FILE *To, char *Pre);
  virtual void       WriteGRP(FILE *To, int Ind);
};


#endif

/* End of pwindcl.h */
